from pyDes import *
from time import time
import os

def double_encrypt(p0,p1,key):
	#Create DES object with the new key
	k = des(key)
	print ("Key: %r" % key.encode("hex"))
	
	#First encryption
	c0 = k.encrypt(p0)
	#Truncate output
	c0 = c0.encode("hex")[:8] 
	print("c0: %r" % c0)

	#Second encrytion
	c1 = k.encrypt(p1)
	#Truncate output
	c1 = c1.encode("hex")[:8] 
	print("c1: %r" % c1)

	#Concatenate the two outputs
	c = (c0+c1).decode("hex")
	print("Ciphertext: %r" % c.encode("hex"))

	return c

def create_table(length,chainlength):

	table = [None] * length

	for i in range(length):

		#Randomly selected startkey for each chain
		startkey = os.urandom(8) 
		print("Random startkey: %r" % startkey)
		key = startkey

		for j in range(chainlength):
			#Plaintexts for the two DES encryptions
			p0 = '\x00\x04\x00\x00\x00\x00\x00\x00'
			p1 = '\x00\x04\xff\xff\x00\x00\x00\x00'

			c = double_encrypt(p0,p1,key)
			key = c
			print("")

		#Add startkey and endkey to the table
		table[i] = (startkey.encode("hex"),key.encode("hex"))
		print table

	#Sort table by endkeys
	table = sorted(table, key=lambda pair: pair[1])
	print("")
	print table
	return table

def reverse_hash(hash, table,chainlength):
	
	#Plaintexts for the two DES encryptions
	p0 = '\x00\x04\x00\x00\x00\x00\x00\x00'
	p1 = '\x00\x04\xff\xff\x00\x00\x00\x00'

	nexthash = hash

	#If no matching endkey is found within the chainlength, 
    # the table does not contain the wanted key
	for y in range(chainlength):
		
		key = nexthash
		print ('Trying key nr %r: %r' % (y+1,key))

		#Search through all the endkeys
		for i in range(len(table)):
			if key==table[i][1]:
				#Matching endkey found
				print('Endkey found: %r' % key)
				endkey = key
				startkey = table[i][0]
				print('Startkey: %r' % startkey)
				startkey = startkey.decode("hex")
				
				#Recreate chain from startkey to the wanted key
				for j in range(chainlength-y-1):
					c = double_encrypt(p0,p1,startkey)
					startkey = c
				#The wanted key is found
				return c.encode("hex")
		
		nexthash = double_encrypt(p0,p1,key.decode("hex")).encode("hex")
	
	print("Key not found")
	return None

# This 100*100 table is added for testing,
# together with the hash value 'e15ed48ca2ab8752'
# and the corresponding key '1945d0157aabb5ea'.
# This hash is located in chain number 76, which has the endkey 'c54f238e17ba1fed'.
table = [('969d225578cd831c', '00eed4e31f888391'), ('471c11e93cec8543', '0115b435bc9c357a'), ('85f490a1f1ec672b', '012d6a7e1e6bd4db'), ('2f0b4e23b7e535e4', '03cec2cc78b6cf65'), ('54f229c64e732357', '076b83d72e235fee'), ('5b8095ce9660edef', '093b05fcf801552c'), ('148205de17d7daa3', '0ae68d3fd6fb922a'), ('c8317303420ae90e', '0b3a5678a8937d61'), ('81d92a7197060221', '0cc6b5b500ec1c5b'), ('1f0d2dc4a7c3fcbf', '0eb47f70bb30669d'), ('85dd45d7fc85ca1d', '0ef629ba369925bb'), ('a95befa6ba0f54f9', '11373d2e89487161'), ('16ccd31a73f708ad', '1223a0f5380f36e5'), ('bab58059931817d2', '125ef9e1ae52ed6f'), ('a425d4fd22c2cc8b', '145a430c0c43a780'), ('ddbdb7c9c18462c7', '1520fd622fbff167'), ('fa704e4d121b049d', '18c1fa92abf251fa'), ('2859b2792bd0ec72', '1a90a73ffe5d8d69'), ('4fb8a162050446ef', '1b89b968e7852e24'), ('c6fc5265f75e7fea', '1ecf130f76a5c3f2'), ('e322eac5443c026b', '1f63d06dc30b5ea2'), ('e2fba085356c8633', '1fefb949e24e883e'), ('5d605ede80874278', '20feb5ae3bb8a23e'), ('352c78c639269666', '234425d82cf65ed9'), ('e6c637c58def1e05', '26dd8fad016a856a'), ('4d890c0ec7e71879', '2fd81901aa8687b2'), ('174e2b6aea9b678b', '33a336503c2ffb88'), ('3568aa74219d2aa2', '36bd0afd4a177395'), ('12abe93ee7bde400', '383c6a79f6b96005'), ('95cacc882ba8bc0e', '396a05d6ca6424c8'), ('aa28516586eb33c6', '3be597d67b3f4e60'), ('b56fde921210a53a', '3f9e6c1bfb73af57'), ('79ddcdae4fa0e0c4', '3ff096a3accdcc54'), ('247a5da296df1779', '40cfa35e8b8f2de2'), ('c7ff0646256fc4c9', '48b7a3e68e3d62fc'), ('9c4d423a3b70f358', '4993a1edc42428e0'), ('b86128a30dec9c6d', '4a8d902116d0aa76'), ('e8c2e1114050b348', '4d7585aeea774e88'), ('8b85139fbc22fa3d', '507f71aa207508af'), ('cca376183c1b43d3', '510d5beef17350c5'), ('9fa7c4d7066eddba', '51c899600fe2d1a6'), ('6ed960cfc3700f93', '5b1a3a4f8faea68f'), ('afb2dc25e685db8f', '5faf289714b64465'), ('74ed58d9b049a460', '72fa7c9bee702503'), ('d1324c314e644bd7', '7920e9083daa6d2d'), ('a557533c9e510b09', '79357d8f4a978560'), ('0473dc81ec0aab39', '7a2fa37c9a0557e7'), ('c67b4dcd7e08ffe8', '7f84e9aa0485b01d'), ('9ae09ad716eb8529', '7fe603d56c23a15b'), ('48ce81b064d76efe', '816d2be151a764b5'), ('417be995a730147e', '8868d0b2f0bef1fb'), ('7af53448753daa91', '8aaf089123bdac60'), ('e0484b9d63bc1a02', '901beade2bacd65f'), ('71f0b9cf46760da4', '9294899010b830ce'), ('fe1d6f008acd65e6', '9410e21dbdaa7a7b'), ('a49497a98af4ded3', '96080e221fd6fe1e'), ('4b9de1fbc5ad7696', '9667d23403d91ea1'), ('4e09d5bd7f6fad6e', '97485d27e98bb491'), ('15b2984b4fa58108', '9a3170f2ceec75a4'), ('4fa0159ebd9dadd0', '9ea8a0d39b96e93a'), ('80260a810d5de597', 'a0f5dcdd2036feb5'), ('6a0db766371d252b', 'a35e9bbe14f6f80d'), ('ff90ed3fc7f896b3', 'a4346a481bb7249a'), ('f2a2d6c745f59cea', 'a585420f444a9317'), ('9e10a4d94808cddc', 'a7774788cf856d5c'), ('300a269d87fe42f3', 'aafeafb0a343f75a'), ('d9c9d371885152cc', 'abdb9cde7f7b397a'), ('ebf751240d44bde4', 'ae275789cf1f058c'), ('d6f47058f031a99e', 'b07e4cff73685d99'), ('5caa7e5375de4486', 'b0c11c479d83ea43'), ('02e3c4b7f07c5e1e', 'b2817ff1a23608c6'), ('9ecfca8db52835a5', 'b7751b44f943e8a9'), ('8e9dd3bcc4fc5acf', 'bb205317795446d8'), ('2c3ee2de9016b426', 'bb591c39a5e88e50'), ('691222bc8c6867e6', 'be210c3711799a28'), ('0813d04cf23a5490', 'bef2fae39956301c'), ('afe8c014376f6446', 'c54e20e9aa0c667b'), ('6866457c5034a08f', 'c54f238e17ba1fed'), ('2de229cf5f754dfa', 'c5933229bde9c48c'), ('8a44e149f50938da', 'cc5453c3455da7fb'), ('0ebae6e014ab27a9', 'ce7f94af3ef7d692'), ('81ad6c2099972091', 'd0978ba342a3bfe5'), ('265df26e3d576147', 'd219950b561ef4a9'), ('2ecc43dae1d1bb78', 'd3cb861edbbd6d1b'), ('6c3d191d4dae7153', 'd4740d7b92550844'), ('09194f28e502cf3d', 'd86c650d378ca76c'), ('57cc95f7b57261d2', 'd9308e0a37f839df'), ('51062b56b46d19b1', 'd96cbde830365549'), ('7c5980390ea95540', 'e0e3120887957a06'), ('d5cc3faa60553649', 'e13811075e53afb5'), ('c4ff2fe68aa8cdd7', 'e7fb9e534ed2d671'), ('146252e998a4ffe7', 'e84ac112dff6fe1e'), ('b11cfd0ebc5ad7ab', 'e8d603d8b07482df'), ('5e7bd76f8700015a', 'e92df9e88f6ea09e'), ('cc051e6c9abbb167', 'f3eac1d03fee7325'), ('d1fe1b1a0df341bc', 'f7fc49944085feb2'), ('f998e477e0f059e0', 'f807660b310a30bb'), ('f0e9ed0472790a5d', 'fa047355b11f1be8'), ('7cac15b953e25d64', 'fa3abcffa88de9b9'), ('a9eaf80456f6e3e9', 'fe657f7f7ee8d551')]
hash = 'e15ed48ca2ab8752'

#t0 = time()
#table = create_table(100,100)
#t1 = time()
#tabletime = t1-t0
#print ('Table created in %ds' % tabletime)

t1 = time()
key = reverse_hash(hash,table,100)
t2 = time()

keytime = t2-t1
print('Key found: %r, in %ds' % (key,keytime))